---
title: "Batman über VXLAN"
date: 2022-11-25T23:31:14+01:00
---

Anbindung der node-Router an die Gateways via VXLAN

<!--more-->

## Motivation

VXLAN ist eine ressourcenschonende Möglichkeit den Layer 2 Tunnel zum Gateway zu realisieren.
Die Erfahrungen mit fastd haben gezeigt, dass dies bei kleinen Routern mit schwacher CPU (z.B WR841) der Flaschenhals ist.\
[SpeedTest Vergleich fastd und VXLAN](speedtest-vxlan-vs-fastd.txt)

Es lassen sich auch sehr günstige Gateways realisieren, die mehrere Hoods performant versorgen können.

## Konzept

Die Daten für den VXLAN-Tunnel erhält der Router mit dem Hoodfile. Ein entsprechender `vpn` Eintrag muss vorhanden sein: 
```
---
    "vpn": [
        {
            "protocol": "vxlan",
            "address": "gateway.url"
        }
    ],
---
```

Der Router konfiguriert damit ein VXLAN Interface `vxlan0` als weiteres batmaninterface.
Das VXLAN interface wird mit einer geringeren `hop_penalty` konfiguriert und somit bevorzugt.

In aller Regel werden die node-Knoten über einen Router mit NAT Funktionalität am Internet teilnehmen. Darüber ist nur ein einziger VXLAN-Tunnel via IPv4 möglich. Diese Einschränkung gilt für IPv6 nicht. Aus diesem Grund ist VXLAN nur via IPv6 implementiert.

Auf den Gateways wird die jeweilige VXLAN Gegenstelle konfiguriert und ebenfalls als weiteres batman-adv Interface in die Hood gehängt.

## Konfiguration des Gateways
[Freifunk-Gateway aufsetzen/VPN/vxlan -> Freifunk Wiki](https://wiki.freifunk-franken.de/w/Freifunk-Gateway_aufsetzen/VPN/vxlan)

## Testen

Zum Testen `http://rl-fff1.fff.community/v2/` als keyserver eintragen. Man findet den Eintrag in der Datei

`/usr/lib/functions/fff/hoodfile`
```
	echo "Getting hoodfile from Keyserver"

	if /bin/busybox wget -T15 -O "$file" "http://rl-fff1.fff.community/v2/?lat=$lat&long=$long"; then
		return 0
```

In den Hoods Schweinfurt, Hassfurt, Ebern, Coburg, Gerolzhofen ist VXLAN aktiv.
